Xenial: Please roll SRU with upstream fix for networkd to "accept colons in network interface names"

Bug #1714933 reported by Tobias Wolf on 2017-09-04
8
This bug affects 1 person
Affects Status Importance Assigned to Milestone
systemd (Ubuntu)
Undecided
Unassigned
Xenial
Undecided
Unassigned
Zesty
Undecided
Unassigned
Artful
Undecided
Unassigned

Bug Description

[Impact]
networkd cannot manage interface names with ':' in them. As used commonly, by convention, by other tools.

[Fix]
Update networkd validation routines and test-suites to accept network interface names with ':' in it.

[Testcase]
Create an inteface with ':' in its name and use it anywhere where systemd validates ifname. E.g. Socket BindToDevice definition, nspawn network zone info, Label= in [Address] section in networkd.

[Regression Potential]
This fix will change validation routines, and thus commands or settings that were previously rejected or ignored will now take effect. Specifically Label= settings in networkd may lead to networking conflicts. The justification for this change is that networkd should really use the sensible ':' ifnames that the user is requesting systemd to use.

[Original Bug Reprot]
PR: https://github.com/systemd/systemd/pull/5117

issue: https://github.com/systemd/systemd/issues/4057

Before the networkd from 231 was backported, it was possible to use interface alias names that contained a colon, e.g. eth0:1. This is commonly used to make legacy tools like "ifconfig" work, because they *expect* a colon in the interface name.

Martin told me to file a bug for this.

Merging networkd from 231 lead to a regression where valid configs were not accepted anymore after the backport. Please merge that fix for the regression.

Tobias Wolf (towolf) on 2017-09-04
summary: - Xenial: Please merge upstream fix for networkd to "accept colons in
- network interface names"
+ Xenial: Please roll SRU with upstream fix for networkd to "accept colons
+ in network interface names"
Changed in systemd (Ubuntu Artful):
status: New → Fix Released
description: updated
Changed in systemd (Ubuntu Zesty):
status: New → In Progress
Changed in systemd (Ubuntu Xenial):
status: New → In Progress

Hello Tobias, or anyone else affected,

Accepted systemd into xenial-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/systemd/229-4ubuntu20 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-xenial to verification-done-xenial. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-xenial. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in systemd (Ubuntu Xenial):
status: In Progress → Fix Committed
tags: added: verification-needed verification-needed-xenial
Tobias Wolf (towolf) wrote :

Confirming the fix. Thanks!

Before:

Sep 19 18:10:39 s1264 systemd-networkd[28308]: [/etc/systemd/network/eth0.network:18] Interface label is not valid or too long, ignoring assignment: eth0:1
Sep 19 18:10:39 s1264 systemd-networkd[28308]: Enumeration completed
Sep 19 18:10:39 s1264 systemd-networkd[28308]: eth0: Configured

After:

Sep 19 22:51:16 s1264 systemd-networkd[11832]: Enumeration completed
Sep 19 22:51:16 s1264 systemd-networkd[11832]: eth0: Configured
Sep 19 22:51:53 s1264 systemd-networkd[20544]: Enumeration completed
Sep 19 22:51:53 s1264 systemd-networkd[20544]: eth0: Configured

eth0:1 Link encap:Ethernet HWaddr 00:25:90:86:71:4c
          inet addr:10.251.0.1 Bcast:10.251.0.255 Mask:255.255.255.0
          UP BROADCAST RUNNING MULTICAST MTU:1500 Metric:1
          Memory:dfb00000-dfbfffff

tags: added: verification-done-xenial
tags: removed: verification-needed-xenial
Dimitri John Ledkov (xnox) wrote :

This is about address lables. Sample .network file to verify this is:

[Match]
MACAddress=52:54:00:8c:9d:b8

[Address]
Address=10.3.0.1/24
Label=ens3:xo:xo

Brian Murray (brian-murray) wrote :

Hello Tobias, or anyone else affected,

Accepted systemd into zesty-proposed. The package will build now and be available at https://launchpad.net/ubuntu/+source/systemd/232-21ubuntu7 in a few hours, and then in the -proposed repository.

Please help us by testing this new package. See https://wiki.ubuntu.com/Testing/EnableProposed for documentation on how to enable and use -proposed.Your feedback will aid us getting this update out to other Ubuntu users.

If this package fixes the bug for you, please add a comment to this bug, mentioning the version of the package you tested and change the tag from verification-needed-zesty to verification-done-zesty. If it does not fix the bug for you, please add a comment stating that, and change the tag to verification-failed-zesty. In either case, details of your testing will help us make a better decision.

Further information regarding the verification process can be found at https://wiki.ubuntu.com/QATeam/PerformingSRUVerification . Thank you in advance!

Changed in systemd (Ubuntu Zesty):
status: In Progress → Fix Committed
tags: added: verification-needed-zesty
Dimitri John Ledkov (xnox) wrote :

With 232-21ubuntu5

Oct 10 08:04:08 darling-stud systemd-networkd[401]: [/run/systemd/network/10-netplan-eth0.network:12] Interface label is not valid or too long, ignoring assignment: xo:xo

With 232-21ubuntu7
inet 10.0.0.1/8 brd 10.255.255.255 scope global xo:xo -> got assigned with correct label.

tags: added: verification-done verification-done-zesty
removed: verification-needed verification-needed-zesty
Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 229-4ubuntu20

---------------
systemd (229-4ubuntu20) xenial; urgency=medium

  * resolved: recognize DNS names with more than one trailing dot as invalid
    (LP: #1600000)
  * Ignore failures to set Nice priority on services in containers.
    (LP: #1709536)
  * networkd: accept `:' in ifnames in systemd/networkd. (LP: #1714933)
  * initramfs-tools: trigger udevadm add actions with subsystems first.
    (LP: #1713536)
  * networkd: Add support to set STP value on a bridge. (LP: #1665088)
  * networkd: add support for AgeingTImeSec, Priority and DefaultPVID settings.
    (LP: #1715131)
    - Drop cherrypick of uint16 config parser, superseeded by above commit.
  * networkd: add support to set ActiveSlave and PrimarySlave. (LP: #1709135)
    - networkd: add support to configure ARP, depedency of Primary/ActiveSlave.

 -- Dimitri John Ledkov <email address hidden> Tue, 05 Sep 2017 14:01:51 +0100

Changed in systemd (Ubuntu Xenial):
status: Fix Committed → Fix Released

The verification of the Stable Release Update for systemd has completed successfully and the package has now been released to -updates. Subsequently, the Ubuntu Stable Release Updates Team is being unsubscribed and will not receive messages about this bug report. In the event that you encounter a regression using the package from -updates please report a new bug using ubuntu-bug and tag the bug report regression-update so we can easily find any regressions.

Launchpad Janitor (janitor) wrote :

This bug was fixed in the package systemd - 232-21ubuntu7

---------------
systemd (232-21ubuntu7) zesty; urgency=medium

  * networkd: accept `:' in ifnames in systemd/networkd. (LP: #1714933)
  * networkd: add support for ActiveSlave and PrimarySlave netdev options.
    (LP: #1709135)
  * Cherrypick upstream fix for a race between .mount and .automount units,
    which currently may result in automounts hanging. (LP: #1709649)
  * systemd.postinst: Fix-up version number check in the previous sru.
    The version check in the postinst was too tight, thus the SRU fix failed
    validation. (LP: #1710410)

systemd (232-21ubuntu6) zesty; urgency=medium

  * link: Fix offload features initialization.
    This fixes a regression introduced in v232 which caused TCP
    segmentation offloads being disabled by default, resulting in
    significant performance issues under certain conditions. (Closes: #864073)
    (LP: #1703393)
  * loginctl: Fix loginctl ignoring user given session IDs at command-line
    (LP: #1682154)
  * Disable fallback DNS servers.
    This causes resolved to call-home to google, attempt to access network when
    none is available, and spams logs. (LP: #1449001)
  * initramfs-tools: trigger udevadm add actions with subsystems first.
    This updates the initramfs-tools init-top udev script to trigger udevadm
    actions with type specified. This mimicks the
    systemd-udev-trigger.service. Without type specified only devices are
    triggered, but triggering subsystems may also be required and should happen
    before triggering the devices. This is the case for example on s390x with zdev
    generated udev rules. (LP: #1713536)
  * Enable systemd-resolved by default. (LP: #1710410)
  * core: fix systemd failing to serialize tasks correctly on daemon-reload.
    (LP: #1702823)

 -- Dimitri John Ledkov <email address hidden> Wed, 04 Oct 2017 14:22:02 +0100

Changed in systemd (Ubuntu Zesty):
status: Fix Committed → Fix Released
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers